%global pypi_name gnocchi
%global with_doc 0

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:           openstack-gnocchi
Version:        4.0.3
Release:        3%{?dist}
Summary:        Gnocchi is a API to store metrics and index resources

License:        ASL 2.0
URL:            http://github.com/gnocchixyz/gnocchi
Source0:        https://pypi.io/packages/source/g/%{pypi_name}/%{pypi_name}-%{version}.tar.gz
Source1:        %{pypi_name}-dist.conf
Source2:        %{pypi_name}.logrotate
Source10:       %{name}-api.service
Source11:       %{name}-metricd.service
Source12:       %{name}-statsd.service

# patches_ignore=DROP-IN-RPM
# patches_base=4.0.3
Patch0001: 0001-rados-Bump-min-version.patch
Patch0002: 0002-py3-pass-a-bytes-type-object-to-tooz-coordinator.patch
Patch0003: 0003-Only-install-futures-on-Python-2.patch
Patch0004: 0004-Make-command-line-tools-log-to-stderr.patch
Patch0005: 0005-rest-fail-properly-if-granularity-is-not-a-timespan.patch
Patch0006: 0006-tests-remove-useless-response_headers-field-that-bre.patch
Patch0007: 0007-doc-do-not-test-gnocchi.xyz-build-on-stable-branch.patch
Patch0008: 0008-tests-Fix-resource-type-with-optional-uuid.patch
Patch0009: 0009-indexer-ap-rule-catch-invalid-ap.patch
Patch0010: 0010-indexer-do-not-return-empty-IN-statement-in-QueryFil.patch
Patch0011: 0011-indexer-fix-upgrade-when-password-contains-a.patch
Patch0012: 0012-Push-tag-to-PyPI-using-Travis.patch
Patch0013: 0013-fix-bad-backports.patch
Patch0014: 0014-set-__ne__-method.patch
Patch0015: 0015-ceph-understandable-error-on-misconfiguration.patch
Patch0016: 0016-redis-make-socket_timeout-optional.patch
Patch0017: 0017-service-log-version-number-at-startup.patch
Patch0018: 0018-indexer-fix-not-operator.patch
Patch0019: 0019-indexer-detach-metric-from-resource-when-marked-as-d.patch

BuildArch:      noarch

BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
BuildRequires:  python-pbr
BuildRequires:  python2-devel
BuildRequires:  systemd
BuildRequires:  python-tenacity >= 4.0.0
BuildRequires:  openstack-macros

%description
HTTP API to store metrics and index resources.

%package -n     python-gnocchi
Summary:        OpenStack gnocchi python libraries

Requires:       numpy >= 1.9.0
Requires:       python-daiquiri
Requires:       python-futures
Requires:       python-iso8601
Requires:       python-jinja2
Requires:       python-keystonemiddleware >= 4.0.0
Requires:       python-lz4 >= 0.9.0
Requires:       python-monotonic
Requires:       python-msgpack
Requires:       python-oslo-config >= 2:3.22.0
Requires:       python-oslo-db >= 4.8.0
Requires:       python-oslo-log >= 2.3.0
Requires:       python-oslo-middleware >= 3.22.0
Requires:       python-oslo-policy >= 0.3.0
Requires:       python-oslo-sphinx >= 2.2.0
Requires:       python-oslo-serialization >= 1.4.0
Requires:       python-oslo-utils >= 3.18.0
Requires:       python-pandas >= 0.18.0
Requires:       python-paste
Requires:       python-paste-deploy
Requires:       python-pbr
Requires:       python-pecan >= 0.9
Requires:       python-pytimeparse >= 1.1.5
Requires:       python-requests
Requires:       python-scipy
Requires:       python-swiftclient >= 3.1.0
Requires:       python-six
Requires:       python-sqlalchemy
Requires:       python-sqlalchemy-utils
Requires:       python-stevedore
Requires:       python-sysv_ipc
Requires:       python-tooz >= 0.30
Requires:       python-trollius
Requires:       python-tenacity >= 4.0.0
Requires:       python-ujson
Requires:       python-voluptuous
Requires:       python-werkzeug
Requires:       pytz
Requires:       PyYAML
Requires:       python-webob >= 1.4.1
Requires:       python-alembic
Requires:       python-psycopg2
Requires:       python-prettytable
Requires:       python-cotyledon >= 1.5.0
Requires:       python-jsonpatch

%description -n   python-gnocchi
OpenStack gnocchi provides API to store metrics from OpenStack components
and index resources.

This package contains the gnocchi python library.


%package        api

Summary:        OpenStack gnocchi api

Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-indexer-sqlalchemy = %{version}-%{release}


%description api
OpenStack gnocchi provides API to store metrics from OpenStack components
and index resources.

This package contains the gnocchi API service.

%package        common
Summary:        Components common to all OpenStackk gnocchi services

# Config file generation
BuildRequires:    python-daiquiri
BuildRequires:    python-jsonpatch
BuildRequires:    python-oslo-config >= 2:3.22.0
BuildRequires:    python-oslo-concurrency
BuildRequires:    python-oslo-db
BuildRequires:    python-oslo-log
BuildRequires:    python-oslo-messaging
BuildRequires:    python-oslo-policy
BuildRequires:    python-oslo-reports
BuildRequires:    python-oslo-service
BuildRequires:    python-lz4 >= 0.9.0
BuildRequires:    python-pandas >= 0.18.0
BuildRequires:    python-pecan >= 0.9
BuildRequires:    python-pytimeparse >= 1.1.5
BuildRequires:    python-tooz
BuildRequires:    python-ujson
BuildRequires:    python-werkzeug
BuildRequires:    python-gnocchiclient >= 2.1.0

Requires:       python-gnocchi = %{version}-%{release}

Obsoletes:        openstack-gnocchi-carbonara

%description    common
OpenStack gnocchi provides services to measure and
collect metrics from OpenStack components.


%package        indexer-sqlalchemy

Summary:        OpenStack gnocchi indexer sqlalchemy driver

Requires:       %{name}-common = %{version}-%{release}


%description indexer-sqlalchemy
OpenStack gnocchi provides API to store metrics from OpenStack
components and index resources.

This package contains the gnocchi indexer with sqlalchemy driver.


%package        metricd

Summary:        OpenStack gnocchi metricd daemon

Requires:       %{name}-common = %{version}-%{release}

%description metricd
OpenStack gnocchi provides API to store metrics from OpenStack
components and index resources.

This package contains the gnocchi metricd daemon


%package        statsd

Summary:        OpenStack gnocchi statsd daemon

Requires:       %{name}-common = %{version}-%{release}

%description statsd
OpenStack gnocchi provides API to store metrics from OpenStack
components and index resources.

This package contains the gnocchi statsd daemon

%package -n python-gnocchi-tests
Summary:        Gnocchi tests
Requires:       python-gnocchi = %{version}-%{release}
Requires:       python-gabbi >= 1.30.0

%description -n python-gnocchi-tests
This package contains the Gnocchi test files.

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack gnocchi

Requires:         python-gnocchi = %{version}-%{release}

%description      doc
OpenStack gnocchi provides services to measure and
collect metrics from OpenStack components.

This package contains documentation files for gnocchi.
%endif


%prep
%setup -q -n gnocchi-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1

find . \( -name .gitignore -o -name .placeholder \) -delete

find gnocchi -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

sed -i '/setup_requires/d; /install_requires/d; /dependency_links/d' setup.py

rm -rf {test-,}requirements.txt tools/{pip,test}-requires


%build

# Generate config file
PYTHONPATH=. oslo-config-generator --config-file=gnocchi/gnocchi-config-generator.conf --output-file=gnocchi/gnocchi.conf

%{__python2} setup.py build

# Programmatically update defaults in sample config
# which is installed at /etc/gnocchi/gnocchi.conf
# TODO: Make this more robust
# Note it only edits the first occurrence, so assumes a section ordering in sample
# and also doesn't support multi-valued variables.
while read name eq value; do
  test "$name" && test "$value" || continue
  sed -i "0,/^# *$name=/{s!^# *$name=.*!#$name=$value!}" gnocchi/gnocchi.conf
done < %{SOURCE1}


%install

%{__python2} setup.py install --skip-build --root %{buildroot}

# Create fake egg-info for the tempest plugin
# TODO switch to %{service} everywhere as in openstack-example.spec
%global service gnocchi
%py2_entrypoint %{service} %{service}

mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig/
mkdir -p %{buildroot}/%{_sysconfdir}/gnocchi/
mkdir -p %{buildroot}/%{_var}/log/%{name}

install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datadir}/gnocchi/gnocchi-dist.conf
install -p -D -m 640 gnocchi/gnocchi.conf %{buildroot}%{_sysconfdir}/gnocchi/gnocchi.conf

#TODO(prad): build the docs at run time, once the we get rid of postgres setup dependency

# Configuration
cp -R gnocchi/rest/policy.json %{buildroot}/%{_sysconfdir}/gnocchi

# Setup directories
install -d -m 755 %{buildroot}%{_sharedstatedir}/gnocchi
install -d -m 755 %{buildroot}%{_sharedstatedir}/gnocchi/tmp
install -d -m 755 %{buildroot}%{_localstatedir}/log/gnocchi

# Install logrotate
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# Install systemd unit services
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/%{name}-api.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/%{name}-metricd.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/%{name}-statsd.service

# Remove all of the conf files that are included in the buildroot/usr/etc dir since we installed them above
rm -f %{buildroot}/usr/etc/gnocchi/*

%pre common
getent group gnocchi >/dev/null || groupadd -r gnocchi
if ! getent passwd gnocchi >/dev/null; then
  useradd -r -g gnocchi -G gnocchi,nobody -d %{_sharedstatedir}/gnocchi -s /sbin/nologin -c "OpenStack gnocchi Daemons" gnocchi
fi
exit 0

%post -n %{name}-api
%systemd_post %{name}-api.service

%preun -n %{name}-api
%systemd_preun %{name}-api.service

%post -n %{name}-metricd
%systemd_post %{name}-metricd.service

%preun -n %{name}-metricd
%systemd_preun %{name}-metricd.service

%post -n %{name}-statsd
%systemd_post %{name}-statsd.service

%preun -n %{name}-statsd
%systemd_preun %{name}-statsd.service

%files -n python-gnocchi
%{python2_sitelib}/gnocchi
%{python2_sitelib}/gnocchi-*.egg-info
%exclude %{python2_sitelib}/gnocchi/tests
%exclude %{python2_sitelib}/gnocchi/tempest

%files -n python-gnocchi-tests
%license LICENSE
%{python2_sitelib}/gnocchi/tests
%{python2_sitelib}/%{service}_tests.egg-info
%{python2_sitelib}/gnocchi/tempest

%files api
%defattr(-,root,root,-)
%{_bindir}/gnocchi-api
%{_unitdir}/%{name}-api.service

%files common
%{_bindir}/gnocchi-config-generator
%{_bindir}/gnocchi-change-sack-size
%dir %{_sysconfdir}/gnocchi
%attr(-, root, gnocchi) %{_datadir}/gnocchi/gnocchi-dist.conf
%config(noreplace) %attr(-, root, gnocchi) %{_sysconfdir}/gnocchi/policy.json
%config(noreplace) %attr(-, root, gnocchi) %{_sysconfdir}/gnocchi/gnocchi.conf
%config(noreplace) %attr(-, root, gnocchi) %{_sysconfdir}/logrotate.d/%{name}
%dir %attr(0750, gnocchi, root)  %{_localstatedir}/log/gnocchi

%defattr(-, gnocchi, gnocchi, -)
%dir %{_sharedstatedir}/gnocchi
%dir %{_sharedstatedir}/gnocchi/tmp


%files indexer-sqlalchemy
%{_bindir}/gnocchi-upgrade

%files metricd
%{_bindir}/gnocchi-metricd
%{_unitdir}/%{name}-metricd.service

%files statsd
%{_bindir}/gnocchi-statsd
%{_unitdir}/%{name}-statsd.service

%if 0%{?with_doc}
%files doc
%doc doc/source/
%endif


%changelog
* Wed Feb 14 2018 Thierry Vignaud <tvignaud@redhat.com> 4.0.3-3
- indexer: detach metric from resource when marked as 'deleted'
- indexer: fix not operator
- service: log version number at startup
- redis: make socket_timeout optional
- ceph: understandable error on misconfiguration
- set __ne__ method
- fix bad backports
- Push tag to PyPI using Travis
- indexer: fix upgrade when password contains a %
- indexer: do not return empty IN statement in QueryFilter
- indexer: ap rule, catch invalid ap
- tests: Fix resource type with optional uuid
- doc: do not test gnocchi.xyz build on stable branch
- tests: remove useless response_headers field that breaks with Gabbi 1.39.0
- rest: fail properly if granularity is not a timespan
- Make command line tools log to stderr
- Only install futures on Python 2
- py3: pass a bytes type object to tooz coordinator

* Fri Nov 10 2017 Jon Schlueter <jschluet@redhat.com> 4.0.3-2
- rados: Bump min version

* Fri Nov 10 2017 Jon Schlueter <jschluet@redhat.com> 4.0.3-1
- Update to 4.0.3

* Thu Aug 24 2017 Alfredo Moralejo <amoralej@redhat.com> 4.0.2-1
- Update to 4.0.2

